--
-- silage mode on/off
--
-- 06/08/09 guimchevalier from TSF3 www.tsforum3.com 


koegel = {};

function koegel.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function koegel:load(xmlFile)

	
	-- graincurve when extension is stock
    self.stock = {};
	self.stock.capacity = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.extension.stock#capacity"), 0);
	local grainAnimCurve = AnimCurve:new(linearInterpolator4);
	local keyI = 0;
	while true do
		local key = string.format("vehicle.extension.stock.key(%d)", keyI);
		local t = getXMLFloat(xmlFile, key.."#time");
		local yValue = getXMLFloat(xmlFile, key.."#y");
		local scaleX,scaleY,scaleZ = Utils.getVectorFromString(getXMLString(xmlFile, key.."#scale"));
		if y == nil or scaleX == nil or scaleY == nil or scaleZ == nil then
			break;
		end;
		grainAnimCurve:addKeyframe({x=scaleX, y=scaleY, z=scaleZ, w=yValue, time = t});
		keyI = keyI +1;
	end;
	if keyI > 0 then
		self.stock.grainAnimCurve = grainAnimCurve;
	end;
	
	
	-- graincurve when extension is half
    self.step1 = {};
	self.step1.capacity = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.extension.step1#capacity"), 0);
	local grainAnimCurve = AnimCurve:new(linearInterpolator4);
	local keyI = 0;
	while true do
		local key = string.format("vehicle.extension.step1.key(%d)", keyI);
		local t = getXMLFloat(xmlFile, key.."#time");
		local yValue = getXMLFloat(xmlFile, key.."#y");
		local scaleX,scaleY,scaleZ = Utils.getVectorFromString(getXMLString(xmlFile, key.."#scale"));
		if y == nil or scaleX == nil or scaleY == nil or scaleZ == nil then
			break;
		end;
		grainAnimCurve:addKeyframe({x=scaleX, y=scaleY, z=scaleZ, w=yValue, time = t});
		keyI = keyI +1;
	end;
	if keyI > 0 then
		self.step1.grainAnimCurve = grainAnimCurve;
	end;
	
	-- graincurve when extension is full
	self.step2 = {};
	self.step2.capacity = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.extension.step2#capacity"), 0);
	local grainAnimCurve = AnimCurve:new(linearInterpolator4);
	local keyI = 0;
	while true do
		local key = string.format("vehicle.extension.step2.key(%d)", keyI);
		local t = getXMLFloat(xmlFile, key.."#time");
		local yValue = getXMLFloat(xmlFile, key.."#y");
		local scaleX,scaleY,scaleZ = Utils.getVectorFromString(getXMLString(xmlFile, key.."#scale"));
		if y == nil or scaleX == nil or scaleY == nil or scaleZ == nil then
			break;
		end;
		grainAnimCurve:addKeyframe({x=scaleX, y=scaleY, z=scaleZ, w=yValue, time = t});
		keyI = keyI +1;
	end;
	if keyI > 0 then
		self.step2.grainAnimCurve = grainAnimCurve;
	end;
	
	self.extensionStep1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extensions#index"));
	self.extensionStep2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extensions#index1"));
	self.extensionBack = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extensions#back"));
	self.extensionLeft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extensions#left"));
	-- first start	
    self.leftPart = true;
	self.extension = 2;
	self.capacity = self.stock.capacity;
	self.grainAnimCurve = self.stock.grainAnimCurve;
end;

function koegel:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	local fillLevel = getXMLFloat(xmlFile, key.."#fillLevel");
    local fillType = getXMLString(xmlFile, key.."#fillType");
    self.extension =  getXMLFloat(xmlFile, key.."#extension");
		if self.extension == 0 then
			self.capacity = self.stock.capacity;
			self.grainAnimCurve = self.stock.grainAnimCurve;
		end;
		if self.extension == 1 then
			self.capacity = self.step1.capacity;
			self.grainAnimCurve = self.step1.grainAnimCurve;
		end;
		if self.extension == 2 then
			self.capacity = self.step2.capacity;
			self.grainAnimCurve = self.step2.grainAnimCurve;
		end;
    if fillLevel ~= nil and fillType ~= nil then
        local fillTypeDesc = FruitUtil.fruitTypes[fillType];
        if fillTypeDesc ~= nil then
            self:setFillLevel(fillLevel, fillTypeDesc.index);
        end;
    end;
    return BaseMission.VEHICLE_LOAD_OK;
end;

function koegel:getSaveAttributesAndNodes(nodeIdent)
	local stocktext='error';
	if self.extension == 0 then
		stocktext='0';
	end;
	if self.extension == 1 then
		stocktext='1';
	end;
	if self.extension == 2 then
		stocktext='2';
	end;    
	
	local attributes = 'extension="'..stocktext..'"';
   return attributes, nil;
end;

function koegel:delete()

end;

function koegel:mouseEvent(posX, posY, isDown, isUp, button)

end;

function koegel:keyEvent(unicode, sym, modifier, isDown)
end;

function koegel:update(dt)
	--capacity grainplane


    if self.extension == 0 then
	    if self.currentFillType == FruitUtil.FRUITTYPE_SILAGE or self.currentFillType == FruitUtil.FRUITTYPE_GRASS  then
		    self.extension = 2;
		else
		    self.capacity = self.stock.capacity;
	        self.grainAnimCurve = self.stock.grainAnimCurve;	
	        setVisibility(self.extensionStep1, false);
    	    setVisibility(self.extensionStep2, false);	
		    setVisibility(self.extensionBack, false);
        end;
	end;
    if self.extension == 1 then
	    if self.currentFillType == FruitUtil.FRUITTYPE_SILAGE or self.currentFillType == FruitUtil.FRUITTYPE_GRASS then
		    self.extension = 2;
		else
		    setVisibility(self.extensionStep1, true);
    	    setVisibility(self.extensionStep2, false);	
		    setVisibility(self.extensionBack, false);
        end;
		if self.leftPart then
			setVisibility(self.extensionLeft, true);
			self.capacity = self.step1.capacity;
			self.grainAnimCurve = self.step1.grainAnimCurve;
		else
		    setVisibility(self.extensionLeft, false);
			self.capacity = self.stock.capacity;
			self.grainAnimCurve = self.stock.grainAnimCurve;
		end;
	end;
    if self.extension == 2 then  
        if self.currentFillType == FruitUtil.FRUITTYPE_SILAGE or self.currentFillType == FruitUtil.FRUITTYPE_GRASS then
            self.capacity = self.step2.capacity;
            self.grainAnimCurve = self.step2.grainAnimCurve;
        else
           self.capacity = self.step1.capacity;
           self.grainAnimCurve = self.step1.grainAnimCurve;
        end;
        setVisibility(self.extensionStep1, true);
        setVisibility(self.extensionStep2, true); 
        setVisibility(self.extensionBack, true);
        setVisibility(self.extensionLeft, true);
    end;
    if self:getIsActiveForInput() then	
	    if self.fillLevel == 0  and InputBinding.hasEvent(InputBinding.koegel_extension) then
		    self.extension = self.extension +1
			if self.extension > 2 then
			    self.extension = 0
			end;
        end;
	end;
	if self.fillLevel == 0 and self.extension == 1 and  InputBinding.hasEvent(InputBinding.koegel_left) then
	    self.leftPart = not self.leftPart;
	end;
	
end;

function koegel:draw()
    if self.attacherVehicle then
	    if self.fillLevel == 0 and self.extension == 0 then
	        g_currentMission:addHelpButtonText(g_i18n:getText("change_to_extension1"), InputBinding.koegel_extension);
		end;
		if self.fillLevel == 0 and self.extension == 1 then
	        g_currentMission:addHelpButtonText(g_i18n:getText("change_to_extension2"), InputBinding.koegel_extension);
	        if self.leftPart then
			    g_currentMission:addHelpButtonText(g_i18n:getText("leftoff"), InputBinding.koegel_left);
			else
			    g_currentMission:addHelpButtonText(g_i18n:getText("lefton"), InputBinding.koegel_left);			
			end;
		end;
		if self.fillLevel == 0 and self.extension == 2 then
	        g_currentMission:addHelpButtonText(g_i18n:getText("change_to_extension0"), InputBinding.koegel_extension);
		end;
	end;
end;

function koegel:onDetach()
end;

function koegel:onAttach()
end;

function koegel:onStartTip(currentTipTrigger)

    g_currentMission.fixedCamera = false;
end;